/* ***************************************************************************
   *  Kindermann                                 WPK Produktentwicklung      *
   *                                             Schuljahr: 2015/16          *
   *                                                                         *
   *                            Pacman VGA 20MHz                             *
   *                            für das USB-Board                            *
   *                                                                         *
   *    Dieses Programm basiert auf dem AVGA Project von Jaromir Dvorak      *
   *    (http://avga.prometheus4.com/) sowie der Pacman-Version von Albert   *
   *    Seward.                                                              *
   *                                                                         *
   *    Es kann unter den Bedingungen der GNU General Public License (GPL)   *
   *    weitergeben und/oder modifiziert werden.                             *
   *                                                                         *
   ***************************************************************************/


#include <stdio.h>
#include "../avga.h"
#include <string.h>
#include "../core/video.h"
#include "../core/driver.h"
#include "../utils/misc.h"
#include "../utils/overlay.h"
#include "../../pacman.h"
#include "highscore.h"
#include "scene.h"
#include "misc.h"


void scene_intro(void) {
	uint8_t  i, mode, tmp;
	int pos, pacman;

	while(key_read(KEY_ANY));


	for(;;) {
		driver_clear();

		//driver_print_C(5,1, "\033\021\021\021\021\021\021\021\032");
		//driver_print_C(5,2, "\020" PACMAN_LOGO "\020");
		//driver_print_C(5,3, "\035\021\021\021\021\021\021\021\034");
		//driver_print_C(4,18, "INSERT COIN");
		//driver_print_C(2,21, "VERSION 2012 VON");
		//driver_print_C(0,22, "DIETRICH KINDERMANN");

		driver_print_C(3,1, "\033\021\021\021\021\021\021\021\032");
		driver_print_C(3,2, "\020" PACMAN_LOGO "\020");
		driver_print_C(3,3, "\035\021\021\021\021\021\021\021\034");
		driver_print_C(2,13, "INSERT COIN");
		driver_print_C(1,15, "20MHZ VERSION");
		driver_print_C(6,17, "VON");
		driver_print_C(4,19, "DIETRICH");
		driver_print_C(3,21, "KINDERMANN");
		sprite_init();

		//pos = 60;
		//pacman = 70;

		pos = 30;
		pacman = 40;

		mode = 1;

        for(;;)
                {

			if(key_read(KEY_COIN))
				return;

			for(i = 1; i < 5; i++)
                        {
				tmp = pos - i * 10;

                //if(tmp < 144 && tmp > 0)                {
				 if(tmp < 110 && tmp > 0)                {
					if(mode)
						sprite_put(5-i, tmp, 70, BLINKY -1 + i);
					else if(pacman < tmp)
						sprite_put(5-i, tmp, 70, EATEN);
					else
						sprite_put(5-i, tmp, 70, EATABLE);
				}
			}

			//if(pacman < 144 && pacman > 0)
			if(pacman < 110 && pacman > 0)
				sprite_put(0, pacman, 70, pacman & 8 ? (mode?PACMAN_OPEN_RIGHT:PACMAN_OPEN_LEFT) : (mode?PACMAN_CLOSED_RIGHT:PACMAN_CLOSED_LEFT));


			if(mode)
                        {
				pos++;
				pacman++;
			}
                        else
                        {
				pos--;
				pacman-=2;
			}


		//if(pos > 144)
		if(pos > 110)
			//pacman = 192;
			pacman = 130;
		else if(pos < -10)
			pacman = 0;


			//if(pos > 250)
            if(pos > 150)
                        {
				mode = 0;
			}
                        else if(pos < -40)
                        {
				//driver_print_C(5,6, "\045  BLINKY");
				//key_wait_timeout(KEY_COIN, 60);
				//driver_print_C(5,7, "\046  CLYDE");
				//key_wait_timeout(KEY_COIN, 60);
				//driver_print_C(5,8, "\047  PINKY");
				//key_wait_timeout(KEY_COIN, 60);
				//driver_print_C(5,9, "\050  INKEY");
				//key_wait_timeout(KEY_COIN, 200);
				//memset(&mode0_get_block(5,6), ' ', 20*4);

				driver_print_C(3,6, "\045  BLINKY");
				key_wait_timeout(KEY_COIN, 60);
				driver_print_C(3,7, "\046  CLYDE");
				key_wait_timeout(KEY_COIN, 60);
				driver_print_C(3,8, "\047  PINKY");
				key_wait_timeout(KEY_COIN, 60);
				driver_print_C(3,9, "\050  INKEY");
				key_wait_timeout(KEY_COIN, 200);
				memset(&mode0_get_block(3,6), ' ', 20*4);


				break;
			}

     		sync();
			sync();
			sprite_clear();

		}
		//highscore_view();
	}
}

